#class Array
#  def each_with_next
#    size.times {|i| yield self[i], self[i+1]}
#  end
#end

module Enumerable
  def each_with_next
    c = n = nil
    each do
      |n|
      yield c, n unless c.nil?
      c = n
    end
    yield c, nil unless c.nil?
  end

  def each_with_next_n(n)
    c = nil
    s = [].fill(nil, 0, n)
    each do
      |e|
      c = s.shift
      s << e
      yield c, s unless c.nil?
    end
    while s.detect {|e| not e.nil?}
      c = s.shift
      s << nil
      yield c, s unless c.nil?
    end
  end
end
